# Dynamically Generated
@builtin "number.ne"
@builtin "string.ne"
@builtin "whitespace.ne"
@{%
    function compact(v) {
        if (Array.isArray(v)) {
            return v.reduce((a, v) => (v === null || v === undefined || (v && v.length === 0) ) ? a : (a.push(v), a), []);
        } else {
            return v;
        }
    }

    function flatten(v) {
        let r;
        if (Array.isArray(v)) {
            r = v.reduce((a,v) => (a.push(...((v && Array.isArray(v)) ? flatten(v) : [v])), a), []);
        } else {
            r = v;
        }
        r = compact(r);
        return r;
        }
%}


rule -> rule0 rule1 rule2 rule3 rule4 rule5 rule6 rule7 rule8 rule9 rule10 rule11 rule12 rule13 rule14 rule15 rule16 rule17 rule18 rule19 rule20 rule21 rule22 rule23 rule24 rule25 rule26 rule27 rule28 
{% ([ rule0,rule1,rule2,rule3,rule4,rule5,rule6,rule7,rule8,rule9,rule10,rule11,rule12,rule13,rule14,rule15,rule16,rule17,rule18,rule19,rule20,rule21,rule22,rule23,rule24,rule25,rule26,rule27,rule28 ]) => {
    return {
        $class: "org.accordproject.acceptanceofdelivery.AcceptanceOfDeliveryClause",
        clauseId : "79cded91-6e1d-4bef-afe3-1c0db7dd6a60",
        shipper : rule1,
        receiver : rule3,
        deliverable : rule5,
        businessDays : rule15,
        attachment : rule27,
    };
}
%}

ROOT -> rule0 
{% ([ rule0 ]) => {
    return {
        
        
    };
}
%}



rule0 -> "Acceptance of Delivery. " 


rule1 -> String {% id %} # shipper 


rule2 -> " will be deemed to have completed its delivery obligations if in " 


rule3 -> String {% id %} # receiver 


rule4 -> "'s opinion, the " 


rule5 -> String {% id %} # deliverable 


rule6 -> " satisfies the Acceptance Criteria, and " 


rule7 -> String {% id %} # receiver 


rule8 -> " notifies " 


rule9 -> String {% id %} # shipper 


rule10 -> " in writing that it is accepting the " 


rule11 -> String {% id %} # deliverable 


rule12 -> ".\n\nInspection and Notice. " 


rule13 -> String {% id %} # receiver 


rule14 -> " will have " 


rule15 -> Long {% id %} # businessDays 


rule16 -> " Business Days' to inspect and evaluate the " 


rule17 -> String {% id %} # deliverable 


rule18 -> " on the delivery date before notifying " 


rule19 -> String {% id %} # shipper 


rule20 -> " that it is either accepting or rejecting the " 


rule21 -> String {% id %} # deliverable 


rule22 -> ".\n\nAcceptance Criteria. The \"Acceptance Criteria\" are the specifications the " 


rule23 -> String {% id %} # deliverable 


rule24 -> " must meet for the " 


rule25 -> String {% id %} # shipper 


rule26 -> " to comply with its requirements and obligations under this agreement, detailed in " 


rule27 -> String {% id %} # attachment 


rule28 -> ", attached to this agreement." 


InspectDeliverable -> DateTime  __  Boolean  __  String  __  DateTime 

{% ( data ) => {
    return {
        $class: "org.accordproject.acceptanceofdelivery.InspectDeliverable",
        deliverableReceivedAt : data[0],
        inspectionPassed : data[2],
        transactionId : data[4],
        timestamp : data[6]
    };
}
%}


InspectionStatus -> "PASSED_TESTING" {% id %} | "FAILED_TESTING" {% id %} | "OUTSIDE_INSPECTION_PERIOD" {% id %} 


InspectionResponse -> InspectionStatus  __  String  __  String  __  String  __  DateTime 

{% ( data ) => {
    return {
        $class: "org.accordproject.acceptanceofdelivery.InspectionResponse",
        status : data[0],
        shipper : data[2],
        receiver : data[4],
        transactionId : data[6],
        timestamp : data[8]
    };
}
%}


AcceptanceOfDeliveryClause -> String  __  String  __  String  __  Long  __  String  __  String 

{% ( data ) => {
    return {
        $class: "org.accordproject.acceptanceofdelivery.AcceptanceOfDeliveryClause",
        shipper : data[0],
        receiver : data[2],
        deliverable : data[4],
        businessDays : data[6],
        attachment : data[8],
        clauseId : data[10]
    };
}
%}


AccordContractState -> String 

{% ( data ) => {
    return {
        $class: "org.accordproject.cicero.contract.AccordContractState",
        stateId : data[0]
    };
}
%}


PaymentObligation -> MonetaryAmount  __  String  __  String  __  String  __  String  __  DateTime:?  __  String  __  DateTime 

{% ( data ) => {
    return {
        $class: "org.accordproject.cicero.runtime.PaymentObligation",
        amount : data[0],
        description : data[2],
        contract : data[4],
        promisor : data[6],
        promisee : data[8],
        deadline : data[10],
        eventId : data[12],
        timestamp : data[14]
    };
}
%}


NotificationObligation -> String  __  String  __  String  __  String  __  String  __  DateTime:?  __  String  __  DateTime 

{% ( data ) => {
    return {
        $class: "org.accordproject.cicero.runtime.NotificationObligation",
        title : data[0],
        message : data[2],
        contract : data[4],
        promisor : data[6],
        promisee : data[8],
        deadline : data[10],
        eventId : data[12],
        timestamp : data[14]
    };
}
%}


Payload -> AccordContract  __  Request  __  AccordContractState:? 

{% ( data ) => {
    return {
        $class: "org.accordproject.cicero.runtime.Payload",
        contract : data[0],
        request : data[2],
        state : data[4]
    };
}
%}


Success -> Response  __  AccordContractState  __  Event:+ 

{% ( data ) => {
    return {
        $class: "org.accordproject.cicero.runtime.Success",
        response : data[0],
        state : data[2],
        emit : data[4]
    };
}
%}


Failure -> ErrorResponse 

{% ( data ) => {
    return {
        $class: "org.accordproject.cicero.runtime.Failure",
        error : data[0]
    };
}
%}


Organization -> String  __  String:?  __  String:?  __  String:?  __  Place:? 

{% ( data ) => {
    return {
        $class: "org.accordproject.organization.Organization",
        identifier : data[0],
        name : data[2],
        description : data[4],
        duns : data[6],
        place : data[8]
    };
}
%}


MonetaryAmount -> Double  __  CurrencyCode 

{% ( data ) => {
    return {
        $class: "org.accordproject.money.MonetaryAmount",
        doubleValue : data[0],
        currencyCode : data[2]
    };
}
%}


CurrencyCode -> "AED" {% id %} | "AFN" {% id %} | "ALL" {% id %} | "AMD" {% id %} | "ANG" {% id %} | "AOA" {% id %} | "ARS" {% id %} | "AUD" {% id %} | "AWG" {% id %} | "AZN" {% id %} | "BAM" {% id %} | "BBD" {% id %} | "BDT" {% id %} | "BGN" {% id %} | "BHD" {% id %} | "BIF" {% id %} | "BMD" {% id %} | "BND" {% id %} | "BOB" {% id %} | "BOV" {% id %} | "BRL" {% id %} | "BSD" {% id %} | "BTN" {% id %} | "BWP" {% id %} | "BYN" {% id %} | "BZD" {% id %} | "CAD" {% id %} | "CDF" {% id %} | "CHE" {% id %} | "CHF" {% id %} | "CHW" {% id %} | "CLF" {% id %} | "CLP" {% id %} | "CNY" {% id %} | "COP" {% id %} | "COU" {% id %} | "CRC" {% id %} | "CUC" {% id %} | "CUP" {% id %} | "CVE" {% id %} | "CZK" {% id %} | "DJF" {% id %} | "DKK" {% id %} | "DOP" {% id %} | "DZD" {% id %} | "EGP" {% id %} | "ERN" {% id %} | "ETB" {% id %} | "EUR" {% id %} | "FJD" {% id %} | "FKP" {% id %} | "GBP" {% id %} | "GEL" {% id %} | "GHS" {% id %} | "GIP" {% id %} | "GMD" {% id %} | "GNF" {% id %} | "GTQ" {% id %} | "GYD" {% id %} | "HKD" {% id %} | "HNL" {% id %} | "HRK" {% id %} | "HTG" {% id %} | "HUF" {% id %} | "IDR" {% id %} | "ILS" {% id %} | "INR" {% id %} | "IQD" {% id %} | "IRR" {% id %} | "ISK" {% id %} | "JMD" {% id %} | "JOD" {% id %} | "JPY" {% id %} | "KES" {% id %} | "KGS" {% id %} | "KHR" {% id %} | "KMF" {% id %} | "KPW" {% id %} | "KRW" {% id %} | "KWD" {% id %} | "KYD" {% id %} | "KZT" {% id %} | "LAK" {% id %} | "LBP" {% id %} | "LKR" {% id %} | "LRD" {% id %} | "LSL" {% id %} | "LYD" {% id %} | "MAD" {% id %} | "MDL" {% id %} | "MGA" {% id %} | "MKD" {% id %} | "MMK" {% id %} | "MNT" {% id %} | "MOP" {% id %} | "MRU" {% id %} | "MUR" {% id %} | "MVR" {% id %} | "MWK" {% id %} | "MXN" {% id %} | "MXV" {% id %} | "MYR" {% id %} | "MZN" {% id %} | "NAD" {% id %} | "NGN" {% id %} | "NIO" {% id %} | "NOK" {% id %} | "NPR" {% id %} | "NZD" {% id %} | "OMR" {% id %} | "PAB" {% id %} | "PEN" {% id %} | "PGK" {% id %} | "PHP" {% id %} | "PKR" {% id %} | "PLN" {% id %} | "PYG" {% id %} | "QAR" {% id %} | "RON" {% id %} | "RSD" {% id %} | "RUB" {% id %} | "RWF" {% id %} | "SAR" {% id %} | "SBD" {% id %} | "SCR" {% id %} | "SDG" {% id %} | "SEK" {% id %} | "SGD" {% id %} | "SHP" {% id %} | "SLL" {% id %} | "SOS" {% id %} | "SRD" {% id %} | "SSP" {% id %} | "STN" {% id %} | "SVC" {% id %} | "SYP" {% id %} | "SZL" {% id %} | "THB" {% id %} | "TJS" {% id %} | "TMT" {% id %} | "TND" {% id %} | "TOP" {% id %} | "TRY" {% id %} | "TTD" {% id %} | "TWD" {% id %} | "TZS" {% id %} | "UAH" {% id %} | "UGX" {% id %} | "USD" {% id %} | "USN" {% id %} | "UYI" {% id %} | "UYU" {% id %} | "UZS" {% id %} | "VEF" {% id %} | "VND" {% id %} | "VUV" {% id %} | "WST" {% id %} | "XAF" {% id %} | "XAG" {% id %} | "XAU" {% id %} | "XBA" {% id %} | "XBB" {% id %} | "XBC" {% id %} | "XBD" {% id %} | "XCD" {% id %} | "XDR" {% id %} | "XOF" {% id %} | "XPD" {% id %} | "XPF" {% id %} | "XPT" {% id %} | "XSU" {% id %} | "XTS" {% id %} | "XUA" {% id %} | "XXX" {% id %} | "YER" {% id %} | "ZAR" {% id %} | "ZMW" {% id %} | "ZWL" {% id %} 


PostalAddress -> String:?  __  String:?  __  String:?  __  String:?  __  String:?  __  String:? 

{% ( data ) => {
    return {
        $class: "org.accordproject.address.PostalAddress",
        streetAddress : data[0],
        postalCode : data[2],
        postOfficeBoxNumber : data[4],
        addressRegion : data[6],
        addressLocality : data[8],
        addressCountry : data[10]
    };
}
%}


GeoCoordinates -> PostalAddress:?  __  String:?  __  Double:?  __  Double:?  __  Double:? 

{% ( data ) => {
    return {
        $class: "org.accordproject.geo.GeoCoordinates",
        address : data[0],
        addressCountry : data[2],
        elevation : data[4],
        latitude : data[6],
        longitude : data[8]
    };
}
%}


Place -> PostalAddress:?  __  String:?  __  String:?  __  GeoCoordinates:?  __  String:?  __  String:?  __  String:?  __  String:? 

{% ( data ) => {
    return {
        $class: "org.accordproject.geo.Place",
        address : data[0],
        branchCode : data[2],
        faxNumber : data[4],
        geo : data[6],
        globalLocationNumber : data[8],
        mapUrl : data[10],
        isicsV4 : data[12],
        telephone : data[14]
    };
}
%}


Country -> String  __  CountryCodeISOAlpha2 

{% ( data ) => {
    return {
        $class: "org.accordproject.geo.Country",
        name : data[0],
        optional : data[2]
    };
}
%}


CountryCodeISOAlpha2 -> "AD" {% id %} | "AE" {% id %} | "AF" {% id %} | "AG" {% id %} | "AI" {% id %} | "AL" {% id %} | "AM" {% id %} | "AO" {% id %} | "AQ" {% id %} | "AR" {% id %} | "AS" {% id %} | "AT" {% id %} | "AU" {% id %} | "AW" {% id %} | "AX" {% id %} | "AZ" {% id %} | "BA" {% id %} | "BB" {% id %} | "BD" {% id %} | "BE" {% id %} | "BF" {% id %} | "BG" {% id %} | "BH" {% id %} | "BI" {% id %} | "BJ" {% id %} | "BL" {% id %} | "BM" {% id %} | "BN" {% id %} | "BO" {% id %} | "BQ" {% id %} | "BR" {% id %} | "BS" {% id %} | "BT" {% id %} | "BV" {% id %} | "BW" {% id %} | "BY" {% id %} | "BZ" {% id %} | "CA" {% id %} | "CC" {% id %} | "CD" {% id %} | "CF" {% id %} | "CG" {% id %} | "CH" {% id %} | "CI" {% id %} | "CK" {% id %} | "CL" {% id %} | "CM" {% id %} | "CN" {% id %} | "CO" {% id %} | "CR" {% id %} | "CU" {% id %} | "CV" {% id %} | "CW" {% id %} | "CX" {% id %} | "CY" {% id %} | "CZ" {% id %} | "DE" {% id %} | "DJ" {% id %} | "DK" {% id %} | "DM" {% id %} | "DO" {% id %} | "DZ" {% id %} | "EC" {% id %} | "EE" {% id %} | "EG" {% id %} | "EH" {% id %} | "ER" {% id %} | "ES" {% id %} | "ET" {% id %} | "FI" {% id %} | "FJ" {% id %} | "FK" {% id %} | "FM" {% id %} | "FO" {% id %} | "FR" {% id %} | "GA" {% id %} | "GB" {% id %} | "GD" {% id %} | "GE" {% id %} | "GF" {% id %} | "GG" {% id %} | "GH" {% id %} | "GI" {% id %} | "GL" {% id %} | "GM" {% id %} | "GN" {% id %} | "GP" {% id %} | "GQ" {% id %} | "GR" {% id %} | "GS" {% id %} | "GT" {% id %} | "GU" {% id %} | "GW" {% id %} | "GY" {% id %} | "HK" {% id %} | "HM" {% id %} | "HN" {% id %} | "HR" {% id %} | "HT" {% id %} | "HU" {% id %} | "ID" {% id %} | "IE" {% id %} | "IL" {% id %} | "IM" {% id %} | "IN" {% id %} | "IO" {% id %} | "IQ" {% id %} | "IR" {% id %} | "IS" {% id %} | "IT" {% id %} | "JE" {% id %} | "JM" {% id %} | "JO" {% id %} | "JP" {% id %} | "KE" {% id %} | "KG" {% id %} | "KH" {% id %} | "KI" {% id %} | "KM" {% id %} | "KN" {% id %} | "KP" {% id %} | "KR" {% id %} | "KW" {% id %} | "KY" {% id %} | "KZ" {% id %} | "LA" {% id %} | "LB" {% id %} | "LC" {% id %} | "LI" {% id %} | "LK" {% id %} | "LR" {% id %} | "LS" {% id %} | "LT" {% id %} | "LU" {% id %} | "LV" {% id %} | "LY" {% id %} | "MA" {% id %} | "MC" {% id %} | "MD" {% id %} | "ME" {% id %} | "MF" {% id %} | "MG" {% id %} | "MH" {% id %} | "MK" {% id %} | "ML" {% id %} | "MM" {% id %} | "MN" {% id %} | "MO" {% id %} | "MP" {% id %} | "MQ" {% id %} | "MR" {% id %} | "MS" {% id %} | "MT" {% id %} | "MU" {% id %} | "MV" {% id %} | "MW" {% id %} | "MX" {% id %} | "MY" {% id %} | "MZ" {% id %} | "NA" {% id %} | "NC" {% id %} | "NE" {% id %} | "NF" {% id %} | "NG" {% id %} | "NI" {% id %} | "NL" {% id %} | "NO" {% id %} | "NP" {% id %} | "NR" {% id %} | "NU" {% id %} | "NZ" {% id %} | "OM" {% id %} | "PA" {% id %} | "PE" {% id %} | "PF" {% id %} | "PG" {% id %} | "PH" {% id %} | "PK" {% id %} | "PL" {% id %} | "PM" {% id %} | "PN" {% id %} | "PR" {% id %} | "PS" {% id %} | "PT" {% id %} | "PW" {% id %} | "PY" {% id %} | "QA" {% id %} | "RE" {% id %} | "RO" {% id %} | "RS" {% id %} | "RU" {% id %} | "RW" {% id %} | "SA" {% id %} | "SB" {% id %} | "SC" {% id %} | "SD" {% id %} | "SE" {% id %} | "SG" {% id %} | "SH" {% id %} | "SI" {% id %} | "SJ" {% id %} | "SK" {% id %} | "SL" {% id %} | "SM" {% id %} | "SN" {% id %} | "SO" {% id %} | "SR" {% id %} | "SS" {% id %} | "ST" {% id %} | "SV" {% id %} | "SX" {% id %} | "SY" {% id %} | "SZ" {% id %} | "TC" {% id %} | "TD" {% id %} | "TF" {% id %} | "TG" {% id %} | "TH" {% id %} | "TJ" {% id %} | "TK" {% id %} | "TL" {% id %} | "TM" {% id %} | "TN" {% id %} | "TO" {% id %} | "TR" {% id %} | "TT" {% id %} | "TV" {% id %} | "TW" {% id %} | "TZ" {% id %} | "UA" {% id %} | "UG" {% id %} | "UM" {% id %} | "US" {% id %} | "UY" {% id %} | "UZ" {% id %} | "VA" {% id %} | "VC" {% id %} | "VE" {% id %} | "VG" {% id %} | "VI" {% id %} | "VN" {% id %} | "VU" {% id %} | "WF" {% id %} | "WS" {% id %} | "YE" {% id %} | "YT" {% id %} | "ZA" {% id %} | "ZM" {% id %} | "ZW" {% id %} 



# Basic types
NUMBER -> [0-9] 
{% (d) => {return parseInt(d[0]);}%}

DOUBLE_NUMBER -> NUMBER NUMBER
{% (d) => {return '' + d[0] + d[1]}%}

MONTH -> DOUBLE_NUMBER
DAY -> DOUBLE_NUMBER
YEAR -> DOUBLE_NUMBER DOUBLE_NUMBER
{% (d) => {return '' + d[0] + d[1]}%}

DATE -> MONTH "/" DAY "/" YEAR
{% (d) => {return '' + d[4] + '-' + d[0] + '-' + d[2]}%}

Word -> [\S]:*
{% (d) => {return d[0].join('');}%}

BRACKET_PHRASE -> "[" Word (__ Word):* "]" {% ((d) => {return d[1] + ' ' + flatten(d[2]).join(" ");}) %}

String -> dqstring {% id %}
Double -> decimal {% id %}
Integer -> int {% id %}
Long -> int {% id %}
Boolean -> "true" {% id %} | "false" {% id %}
DateTime -> DATE  {% id %}